//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main()
{

  set<int> coll;

  INSERT_ELEMENTS(coll,1,9);
  PRINT_ELEMENTS(coll," :\n");

  //         
  set<int>::iterator pos = coll.begin();
  advance(pos,1);
  cout << ToRus("        :\n");
  rotate_copy(coll.begin(),                     //  
              pos,                              //   
              coll.end(),                       //  
              ostream_iterator<int>(cout," ")); // 
  cout << endl;

  //         
  pos = coll.end();
  advance(pos,-2);
  cout << ToRus("        :\n");
  rotate_copy(coll.begin(),                     //  
              pos,                              //   
              coll.end(),                       //  
              ostream_iterator<int>(cout," ")); // 
  cout << endl;

  //     ,   
  //    4   
  cout << ToRus("    \n  4  :\n");
  rotate_copy(coll.begin(),                     //  
              coll.find(4),                     //   
              coll.end(),                       //  
              ostream_iterator<int>(cout," ")); // 
  cout << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------